var rq_hq_map;

function parse(hash_s, callback) {
  rq_hq_map = JSON.parse(hash_s);
  if (Object.keys(rq_hq_map).length) callback(rq_hq_map);
}

function set_map(callback, always) {
  chrome.storage.sync.get('rq_hq_map_last_failed', function(items) {
    var last_failed = typeof chrome.runtime.lastError !== 'undefined' ? Date.now() : items.rq_hq_map_last_failed;
    if (always || last_failed == null || Date.now()-last_failed > 3e5) {
      var xhr = new XMLHttpRequest();
      xhr.open('GET', 'https://tubeacca.com/lovers/rq_hq_map.json', true);
      xhr.onreadystatechange = function() {
        if (xhr.readyState == XMLHttpRequest.DONE) {
          if (xhr.status === 200 && xhr.responseText) {
            hash_s = xhr.responseText;
            chrome.storage.sync.set({rq_hq_map: hash_s});
            parse(hash_s, callback);
          } else {
            chrome.storage.sync.set({rq_hq_map_last_failed: Date.now()});
          }
        }
      };
      xhr.send();
    }
  });
}

function get_map(callback) {
  if (rq_hq_map) {
    callback(rq_hq_map);
  } else {
    chrome.storage.sync.get('rq_hq_map', function (items) {
      if (!chrome.runtime.lastError) {
        if (items.rq_hq_map) {
          parse(items.rq_hq_map, callback);
        } else {
          set_map(callback);
        }
      }
    });
  }
}

function add_q_link(url, video_id, type, original, title, style) {
  var q_link = document.createElement('A');
  q_link.href = url;
  if (video_id) mod_video_id(q_link, video_id);
  q_link.title = title;
  q_link.appendChild(document.createTextNode(type + 'Q'));
  q_link.style = style || 'float: right; margin-right: 10px; font-style: italic; margin-top:5px; color: white; background: #8600c8; padding: 5px; border-radius: 4px; text-decoration: none;';
  var heading = original.parentNode;
  heading.appendChild(q_link);
  return q_link;
}

function get_video_id(url) {
  return url.search.substr(3, 11);
}

function mod_video_id(link, new_video_id) {
  link.search = 'v=' + new_video_id + link.search.substr(14);
}
