function fix_nyt_links() {
  var embeds = document.querySelectorAll('iframe[src*="://www.youtube.com/embed/"]');
  var llinks = document.querySelectorAll('a[href*="youtube.com/watch?v="]');
  var slinks = document.querySelectorAll('a[href*="://youtu.be/"]');

  if (embeds.length  || llinks.length || slinks.length) {

    get_map(function (rq_hq_map) {

      if (embeds.length) {
        var vid_match = /embed\/([^?]*)/;
        embeds.forEach(function(embed) {
          var video_id = embed.src.match(vid_match)[1];
          var hq_video_id = rq_hq_map[video_id];
          if (hq_video_id) {
            var youtube_url = 'https://www.youtube.com/watch?v=' + hq_video_id;
            var container = document.createElement('SPAN');
            container.style = 'position: relative';
            link_style = 'position: absolute; left: 50%; bottom: 10px;font-style: italic';
            embed.parentNode.replaceChild(container, embed);
            container.appendChild(embed);
            add_q_link(youtube_url, null, 'H', embed, 'High-Quality Version', link_style);
          }
        });
      }

      if (llinks.length) {
        llinks.forEach(function(link) {
          var video_id = get_video_id(link);
          var hq_video_id = rq_hq_map[video_id];
          if (hq_video_id) mod_video_id(link, hq_video_id);
        });
      }
        
      if (slinks.length) {
        slinks.forEach(function(link) {
          var video_id = link.pathname.substr(1);
          var hq_video_id = rq_hq_map[video_id];
          if (hq_video_id) link.pathname = hq_video_id;
        });
      }
    });
  }
}

fix_nyt_links();
document.addEventListener('turbolinks:load', fix_nyt_links, true);
