function fix_links() {
  var links = document.querySelectorAll('a[href^="/watch?v="]');
  var video_page = location.pathname == '/watch';

  if (links.length > 0 || video_page) {
    get_map(function (rq_hq_map) {
    
      function make_hq_title(rq_title) {
         return rq_title.replace(/[—-]* *[([]?reduced quality[)[]?/i, '');
      }
      
      // links.forEach(function(link) { doesn't work in Edge
      //
      for (i=links.length-1; i>=0; --i) {
        link = links[i];
        var video_id = get_video_id(link);
        var hq_video_id = rq_hq_map[video_id];
        if (hq_video_id) {
          var title = link.firstChild;
          if (title.nodeType == 3) { // Text node = title heading
            add_q_link(link.href, null, 'R', link, title.nodeValue);
            var hq_title = make_hq_title(title.nodeValue);
            title.nodeValue = hq_title;
            link.title = hq_title + ' (High Quality)';
          }
          mod_video_id(link, hq_video_id);
        }
      }
      
      if (video_page) {
        var video_id = get_video_id(location);
        var title_el = document.getElementById('eow-title');
        var title = title_el.title;
        var href = location.href;
        var container = title_el.parentNode;
        var hq_video_id = rq_hq_map[video_id];
        if (hq_video_id) {
          var hq_title = make_hq_title(title) + ' (High Quality)';
          add_q_link(href, hq_video_id, 'H', container, hq_title);
        } else {
          for (var rq_video_id in rq_hq_map) if (video_id === rq_hq_map[rq_video_id]) {
            add_q_link(href, rq_video_id, 'R', container, title + ' (Reduced Quality)');
            break;
          }
        }
      }

    });
  }
}

var seen_progress = false;

function check_for_progress() {
  page_load_in_progress = document.getElementById('progress') != null;
  
  if (seen_progress && !page_load_in_progress) {
    seen_progress = false;
    fix_links();
  } else if (page_load_in_progress) {
    seen_progress = true;
  }
}

var observer = new MutationObserver(check_for_progress);
observer.observe(document.body, {childList: true});

fix_links();

